import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "igniteui-react-core";
import { DomRenderer, DomWrapper } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { ControlDisplayDensity } from "igniteui-react-core";
import { BaseControlTheme } from "igniteui-react-core";
import { Brush } from "igniteui-react-core";
import { FontInfo } from "igniteui-react-core";
import { DayOfWeek } from "./DayOfWeek";
import { FirstWeek } from "./FirstWeek";
import { ValueChangedEventArgs } from "./ValueChangedEventArgs";
import { CalendarVisualModelExport } from "./CalendarVisualModelExport";
/**
 * @hidden
 */
export declare class CalendarView extends Base {
    static $t: Type;
    private j;
    private k;
    private n;
    private m;
    private o;
    private f;
    private e;
    private g;
    private h;
    private l;
    private q;
    constructor();
    c: Calendar;
    ad(): void;
    i: DomRenderer;
    ac(a: DomRenderer): void;
    r(): string;
    private u;
    private am;
    an(): void;
    private al;
    ap(): void;
    aq(): void;
    ak(): void;
    ah(a?: boolean, b?: boolean): void;
    aj(): void;
    ao(): void;
    ag(a?: boolean): void;
    ai(a?: boolean): void;
    d(a: DomWrapper): boolean;
    w(): void;
    private af;
    private aa;
    private ar;
    private as;
    private s;
    private t;
    private p;
    private ae;
    private z;
    private y;
    private av;
    private v;
    private x;
    private at;
    private au;
    a(): number[];
    b(a: DomWrapper): number[];
    ab(): void;
}
/**
 * @hidden
 */
export declare class Calendar extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private k;
    private static readonly bh;
    private static readonly bi;
    an: Date;
    private aj;
    private ae;
    private af;
    private ac;
    private ag;
    private ai;
    private ah;
    private ad;
    private h;
    private am;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    constructor();
    close: (sender: any) => void;
    cl(): void;
    valueChanged: (sender: any, args: ValueChangedEventArgs) => void;
    cn(a: Date): void;
    ch(a: string, b: string, c: string): void;
    notifySizeChanged(): void;
    destroy(): void;
    provideContainer(a: DomRenderer): void;
    private u;
    private readonly v;
    private ap;
    at: Date;
    private ao;
    as: Date;
    private al;
    ar: Date;
    private ak;
    aq: Date;
    private e;
    f: ControlDisplayDensity;
    private c;
    d: BaseControlTheme;
    private c8;
    di: Brush;
    private de;
    dp: Brush;
    private dg;
    dr: Brush;
    private db;
    dl: Brush;
    private dd;
    dn: Brush;
    private dh;
    ds: Brush;
    private df;
    dq: Brush;
    private dc;
    dm: Brush;
    private da;
    dk: Brush;
    private c9;
    dj: Brush;
    private w;
    z: boolean;
    private s;
    t: FontInfo;
    private m;
    n: DayOfWeek;
    private p;
    q: FirstWeek;
    private x;
    aa: boolean;
    protected cm(a: string, b: any, c: any): void;
    protected co(a: string, b: any, c: any): void;
    private c6;
    private c7;
    cj(): void;
    private cv;
    private ct;
    cg(): void;
    private cq;
    cb(a: DomRenderer, b: DomWrapper, c: DomWrapper, d: List$1<DomWrapper>): void;
    ce(a: DomRenderer, b: DomWrapper): void;
    private c5;
    c4(a: DomWrapper): void;
    cd(a: DomRenderer, b: DomWrapper, c: List$1<DomWrapper>): void;
    cf(a: DomRenderer, b: DomWrapper, c: List$1<DomWrapper>): void;
    private cc;
    private ab;
    private a6;
    private static readonly a;
    private static readonly b;
    private a7;
    private a5;
    private a8;
    private a9;
    private a4;
    private o;
    private a3;
    private ba;
    private static y;
    cx(a: DomRenderer, b: DomWrapper, c: List$1<DomWrapper>): void;
    b8(a: List$1<DomWrapper>): void;
    cu(a: DomWrapper): void;
    c3(a: DomWrapper): void;
    cz(a: DomWrapper): void;
    cw(a: List$1<DomWrapper>, b?: boolean, c?: boolean): void;
    c0(a: DomWrapper): void;
    cy(a: List$1<DomWrapper>): void;
    c2(a: List$1<DomWrapper>): void;
    c1(a: List$1<DomWrapper>, b: number, c?: boolean): void;
    private j;
    private i;
    b7(a: number): void;
    b9(a: number): void;
    ca(a: number): void;
    cs(a: List$1<DomWrapper>, b: number): void;
    cr(): void;
    bg(): any;
    bp(): string;
    g(): CalendarVisualModelExport;
}
